﻿
// PL2523_6GPIODlg.h: 標頭檔
//

#pragma once

#include <setupapi.h>

typedef struct _COM_PORT_DEVICE {
	DWORD dwDeviceIndex;
	//DWORD dwRegistryType;
	WCHAR wchPhysicalDeviceObjectName[MAX_PATH];
	WCHAR wchDriver[MAX_PATH];
	WCHAR wchDeviceAddress[MAX_PATH];
	WCHAR wchHardwareId[MAX_PATH];
	WCHAR wchFriendlyName[MAX_PATH];
	WCHAR wchLocationInfo[MAX_PATH];
	WCHAR wchLocationPath[MAX_PATH];
} COM_PORT_DEVICE, * PCOM_PORT_DEVICE;

#define MAX_DEVICE_COUNT	128

// CPL25236GPIODlg 對話方塊
class CPL25236GPIODlg : public CDialogEx
{
	DCB m_DCB;

// 建構
public:
	CPL25236GPIODlg(CWnd* pParent = nullptr);	// 標準建構函式

// 對話方塊資料
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_PL2523_6GPIO_DIALOG };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV 支援
	COM_PORT_DEVICE m_ComPortDeviceArray[MAX_DEVICE_COUNT];

// 程式碼實作
protected:
	HICON m_hIcon;
	HANDLE m_hCOM;

	//For PL2523
	CString str_Response;
	CString strResponse;

	// 產生的訊息對應函式
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedBtnOpen();
	void AddResponseString(CString& str);
	afx_msg void OnBnClickedButClose();
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnBnClickedBtnSetstatus();
	afx_msg void OnBnClickedBtnGetstatus();
	CButton mc_TX_LED0_CE;
	CButton mc_TX_LED0_OE;
	CButton mc_TX_LED0_Get;
	CButton mc_TX_LED0_Set;
	CEdit mc_TX_LED0_edit;
	afx_msg void OnBnClickedChkTxLed0Ce();
	CString PL2523_CE_Printlog(int errorcode, BOOL enable, int PortNumber, int Channel);
	afx_msg void OnBnClickedChkTxLed0Oe();
	CString PL2523_OE_Printlog(int errorcode, BOOL enable, int PortNumber, int Channel);
	afx_msg void OnBnClickedBtnGetTxLed0();
	CString PL2523_Getval_Printlog(int PortNumber, int Channel, BYTE val);
	BYTE val;
	afx_msg void OnBnClickedBtnSetTxLed0();
	CString PL2523_Setval_Printlog(int PortNumber, int Channel, BYTE val);
	BYTE mv_TX_LED0_edit;
	afx_msg void OnEnChangeEditSetvalueTxLed0();
	CButton mc_RX_LED0_CE;
	CButton mc_RX_LED0_OE;
	CButton mc_RX_LED0_Get;
	CButton mc_RX_LED0_Set;
	CEdit mc_RX_LED0_edit;
	BYTE mv_Rx_LED0_edit;
	afx_msg void OnBnClickedChkRxLed0Ce();
	afx_msg void OnBnClickedChkRxLed0Oe();
	afx_msg void OnBnClickedBtnGetRxLed0();
	afx_msg void OnBnClickedBtnSetRxLed0();
	CButton mc_TX_LED1_CE;
	CButton mc_TX_LED1_OE;
	CButton mc_TX_LED1_Get;
	CButton mc_TX_LED1_Set;
	CEdit mc_TX_LED1_edit;
	CString mv_TX_LED1_edit;
	afx_msg void OnBnClickedBtnSetTxLed1();
	afx_msg void OnBnClickedChkTxLed1Ce();
	afx_msg void OnBnClickedBtnGetTxLed1();
	afx_msg void OnBnClickedChkTxLed1Oe();
	CButton mc_RX_LED1_CE;
	CButton mc_RX_LED1_OE;
	CButton mc_RX_LED1_Get;
	CButton mc_RX_LED1_Set;
	CEdit mc_RX_LED1_edit;
	BYTE mv_RX_LED1_edit;
	afx_msg void OnBnClickedChkTxLed1Ce2();
	afx_msg void OnBnClickedChkTxLed1Oe2();
	afx_msg void OnBnClickedBtnGetTxLed2();
	afx_msg void OnBnClickedBtnSetTxLed2();
	CButton mc_P2_7_CE;
	CButton mc_P2_7_OE;
	CButton mc_P2_7_Get;
	CButton mc_P2_7_Set;
	CEdit mc_P2_7_edit;
	BYTE mv_P2_7_edit;
	afx_msg void OnBnClickedChkTxLed1Ce4();
	afx_msg void OnBnClickedChkTxLed1Oe4();
	afx_msg void OnBnClickedBtnGetTxLed4();
	afx_msg void OnBnClickedBtnSetTxLed4();
	CButton mc_P2_9_CE;
	CButton mc_P2_9_OE;
	CButton mc_P2_9_Get;
	CButton mc_P2_9_Set;
	CEdit mc_P2_9_edit;
	BYTE mv_P2_9_edit;
	afx_msg void OnBnClickedChkTxLed1Ce5();
	afx_msg void OnBnClickedChkTxLed1Oe5();
	afx_msg void OnBnClickedBtnGetTxLed5();
	afx_msg void OnBnClickedBtnSetTxLed5();
	CComboBox m_cboDevice;
	afx_msg void OnCbnSelchangeComboPort();
	afx_msg void OnBnClickedButRefresh();
	UINT EnumDevice(GUID& DeviceGuid, CComboBox& cboDevice); //方法1，尋找全部Com Port
	void Refresh_067B();//方法2，只尋找067B Com Port
	UINT EnumDevice_067B(GUID& DeviceGuid, CComboBox& cboDevice); //方法2，只尋找067B Com Port
	void Refresh_Final(); //方法3，可全部尋找或指定067B...
	UINT EnumDevice_Final(GUID& DeviceGuid, CComboBox& cboDevice, CString srtVIDPID);//方法3，可全部尋找或指定067B...
	BOOL GetRegistryProperty(HDEVINFO hDeviceInfo, SP_DEVINFO_DATA& devInfoData, DWORD RegistryProperty, WCHAR* wchBuffer);
	UINT m_unDeviceCount;
	
	afx_msg void OnBnClickedButton1();
	BOOL OnDeviceChange(UINT nEventType, DWORD dwData);
	CButton m_Refresh;
	CButton mc_P3_10_CE;
	CButton mc_P3_10_OE;
	CButton mc_P3_10_Get;
	CButton mc_P3_10_Set;
	CEdit mc_P3_10_edit;
	BYTE mv_P3_10_edit;
	afx_msg void OnBnClickedChkP310Ce();
	afx_msg void OnBnClickedChkP310Oe();
	afx_msg void OnBnClickedBtnGetP310();
	afx_msg void OnBnClickedBtnSetP310();
//	afx_msg void OnEnChangeEditSetvalueTxLed5();
	afx_msg void OnBnClickedRefresh067b();
	afx_msg void OnBnClickedRefreshfinal();
};
